#pragma once

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define RINGBUFFER_SIZE_DEFAULT 88200

class CRingBuffer
{
protected:
	int buffersize;
	int read_pos;
	int write_pos;

	float *buffer;

public:
	CRingBuffer(void);
	~CRingBuffer(void);

	void Resize(int size = RINGBUFFER_SIZE_DEFAULT);

	float GetValue(int position = 0);
	float GetValueWithLerp(float position);
	void SetValue(float value);

	void SetInterval(int interval);

	void ForwardReadPosition(int forward = 1);
	void ForwardWritePosition(int forward = 1);
};
