// ============================================================================================
// CN[ht@C
// ============================================================================================
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <windows.h>

#include "audioeffectx.h"

//fBCp̏zobt@NX`̃CN[h
#include "CRingBuffer.h"

// ============================================================================================
// ݌v̋L
// ============================================================================================
#define MY_VST_VENDOR       "test vendor"        //(x_[)
#define MY_VST_VERSION      1                    //VSTo[W
#define MY_VST_PRODUCT_NAME "Sample Chorus VST"  //VST̐i
#define MY_VST_NAME         "Chorus"             //VST̖O

#define MY_VST_INPUT_NUM   2 //͐Bm=1AXeI=2
#define MY_VST_OUTPUT_NUM  2 //o͐Bmo=1AXeIo=2

#define MY_VST_UNIQUE_ID  'SMPL' //j[NID
                                 //Jꍇ͈ȉURLŔsꂽj[NID͂B
                                 //http://ygrabit.steinberg.de/~ygrabit/public_html/index.html

#define MY_VST_PRESET_NUM    1 //vZbgvO̐
#define MY_VST_PARAMETER_NUM 4 //p[^̐

//VST̃p[^`ĂB
//0̘AԂłȂ΂ȂȂB
#define CHORUS_DRYWET    0
#define CHORUS_RATE     1
#define CHORUS_DEPTH    2
#define CHORUS_FEEDBACK 3

// ============================================================================================
// VST̊{ƂȂNX
// ============================================================================================
class MyChorusVST : public AudioEffectX
{
protected:
	CRingBuffer RingBufL;
	CRingBuffer RingBufR;

	float fTime;
	float fChorusDW;
	float fChorusRate;
	float fChorusDepth;
	float fChorusFeedback;

public:
	MyChorusVST (audioMasterCallback audioMaster);
	~MyChorusVST ();

	//(x_[)Ao[WAiAVST̖O
	//HostAvP[V֒m点郁o[֐
	virtual bool getVendorString (char* text);
	virtual VstInt32 getVendorVersion ();
	virtual bool getProductString (char* text);
	virtual bool getEffectName (char* name);

	// GtFN^[̃p[^Ɋւ郁o[֐
	virtual void  setParameter (VstInt32 index, float value);
	virtual float getParameter (VstInt32 index);
	virtual void  getParameterName (VstInt32 index, char* text);
	virtual void  getParameterLabel (VstInt32 index, char* label);
	virtual void  getParameterDisplay (VstInt32 index, char* text);

	// M郁o[֐
	virtual void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames);
};

// ============================================================================================
// VST̂𐶐邽߂̊֐
// ============================================================================================
AudioEffect* createEffectInstance (audioMasterCallback audioMaster)
{
	//newłVST𐶐|C^Ԃ
	return new MyChorusVST (audioMaster);
}

// ============================================================================================
// RXgN^AfXgN^(VST̏AILq)
// ============================================================================================
MyChorusVST::MyChorusVST (audioMasterCallback audioMaster)
: AudioEffectX (audioMaster, MY_VST_PRESET_NUM, MY_VST_PARAMETER_NUM)
{
	//VST̏sB

	//ȉ̊֐Ăяoē͐Ao͐̏ݒ肷B
	//KĂяoȂ΂ȂȂB
	setNumInputs (MY_VST_INPUT_NUM);    //͐̐ݒ
	setNumOutputs (MY_VST_OUTPUT_NUM);  //o͐̐ݒ
	setUniqueID (MY_VST_UNIQUE_ID);     //j[NID̐ݒ

	isSynth (false);          //VSTSynthǂ̃tOݒB
	                         //Synth̏ꍇctrueAEffectoȑꍇcfalse

	canProcessReplacing ();  //VST\ǂ̃tOݒB
	                         //sȂVST͂Ȃ̂ŕK̊֐ĂяoB

	//VST̃p[^B
	fTime = 0.0f;

	fChorusDW    = 0.4f;
	fChorusRate     = 1.1f; //ő16Hzx
	fChorusDepth    = 6.3f; //ő40msx
	fChorusFeedback = 0.04f;  //ő95%x

	RingBufL.SetInterval((int)(fChorusDepth * getSampleRate() / 1000.0f));
	RingBufR.SetInterval((int)(fChorusDepth * getSampleRate() / 1000.0f));
}

MyChorusVST::~MyChorusVST ()
{
	//VST̏IB
	//VSTł͓Ɏs鏈͂ȂB
}

// ============================================================================================
// (x_[)Ao[WAiAVST̖OHostAvP[V֒m点郁o[֐
// ============================================================================================
bool MyChorusVST::getVendorString (char* text)
{
	//(x_[)textɊi[trueԂB
	//kVstMaxVendorStrLeńuvstsdk2.4\pluginterfaces\vst2.x\aeffect.hv
	//`ĂB(kVstMaxVendorStrLen = 64)
	vst_strncpy (text, MY_VST_VENDOR, kVstMaxVendorStrLen);
	return true;
}

VstInt32 MyChorusVST::getVendorVersion ()
{
	//o[W()ԂB
	return MY_VST_VERSION;
}

bool MyChorusVST::getProductString (char* text)
{
	//itextɊi[trueԂB
	//kVstMaxProductStrLeńuvstsdk2.4\pluginterfaces\vst2.x\aeffect.hv
	//`ĂB(kVstMaxProductStrLen = 64)
	vst_strncpy (text, MY_VST_PRODUCT_NAME, kVstMaxProductStrLen);
	return true;
}

bool MyChorusVST::getEffectName (char* name)
{
	//inameɊi[trueԂB
	//kVstMaxEffectNameLeńuvstsdk2.4\pluginterfaces\vst2.x\aeffect.hv
	//`ĂB(kVstMaxEffectNameLen = 32)
	vst_strncpy (name, MY_VST_NAME, kVstMaxEffectNameLen);
	return true;
}

// ============================================================================================
// GtFN^[̃p[^[̐ݒA\so[֐
// ============================================================================================
void  MyChorusVST::setParameter (VstInt32 index, float value)
{
	//indexŎw肳ꂽp[^ɒlݒ肷B
	//value0.0f`1.0fŗ^B
	switch (index)
	{
	case CHORUS_DRYWET:
		fChorusDW = value;
		break;
	case CHORUS_RATE:
		fChorusRate = 15.9f * value + 0.1f; //0.1Hz`16Hz
		break;
	case CHORUS_DEPTH:
		fChorusDepth = 39.6f * value + 0.4f; //0.4~b`40~b
		RingBufL.SetInterval((int)(fChorusDepth * getSampleRate() / 1000.0f));
		RingBufR.SetInterval((int)(fChorusDepth * getSampleRate() / 1000.0f));
		break;
	case CHORUS_FEEDBACK:
		fChorusFeedback = value * 0.95f;
		break;
	}
}

float MyChorusVST::getParameter (VstInt32 index)
{
	//indexŎw肳ꂽp[^̒l
	//0.0f`1.0f͈̔͂ŕԂ
	float value = 0.0f;
	switch (index)
	{
	case CHORUS_DRYWET:
		value = fChorusDW;
		break;
	case CHORUS_RATE:
		value = (fChorusRate - 0.1f) / 15.9f; //1Hz`16Hz0.0f`1.0f͈̔͂ɂ
		break;
	case CHORUS_DEPTH:
		value = (fChorusDepth - 0.4f) / 39.6f; //0.4~b`40~b0.0f`1.0f͈̔͂ɂ
		break;
	case CHORUS_FEEDBACK:
		value = fChorusFeedback / 0.95f;
		break;
	}
	return value;
}

void  MyChorusVST::getParameterName (VstInt32 index, char* text)
{
	//indexŎw肳ꂽp[^̖OtextɊi[
	//kVstMaxParamStrLeńuvstsdk2.4\pluginterfaces\vst2.x\aeffect.hv
	//`ĂB(kVstMaxParamStrLen = 8)
	switch (index)
	{
	case CHORUS_DRYWET:
		vst_strncpy (text, "level", kVstMaxParamStrLen);
		break;
	case CHORUS_RATE:
		vst_strncpy (text, "rate", kVstMaxParamStrLen);
		break;
	case CHORUS_DEPTH:
		vst_strncpy (text, "depth", kVstMaxParamStrLen);
		break;
	case CHORUS_FEEDBACK:
		vst_strncpy (text, "feedbk", kVstMaxParamStrLen);
		break;
	}
}

void  MyChorusVST::getParameterLabel (VstInt32 index, char* label)
{
	//indexŎw肳ꂽp[^̒PʂlabelɊi[
	//kVstMaxParamStrLeńuvstsdk2.4\pluginterfaces\vst2.x\aeffect.hv
	//`ĂB(kVstMaxParamStrLen = 8)
	switch (index)
	{
	case CHORUS_DRYWET:
		vst_strncpy (label, "%", kVstMaxParamStrLen);
		break;
	case CHORUS_RATE:
		vst_strncpy (label, "Hz", kVstMaxParamStrLen);
		break;
	case CHORUS_DEPTH:
		vst_strncpy (label, "m sec", kVstMaxParamStrLen);
		break;
	case CHORUS_FEEDBACK:
		vst_strncpy (label, "%", kVstMaxParamStrLen);
		break;
	}
}

void  MyChorusVST::getParameterDisplay (VstInt32 index, char* text)
{
	//indexŎw肳ꂽp[^̕\etextɊi[
	//kVstMaxParamStrLeńuvstsdk2.4\pluginterfaces\vst2.x\aeffect.hv
	//`ĂB(kVstMaxParamStrLen = 8)
	switch (index)
	{
	case CHORUS_DRYWET:
		float2string (fChorusDW * 100.0f, text, kVstMaxParamStrLen);
		break;
	case CHORUS_RATE:
		float2string (fChorusRate, text, kVstMaxParamStrLen);
		break;
	case CHORUS_DEPTH:
		float2string (fChorusDepth, text, kVstMaxParamStrLen);
		break;
	case CHORUS_FEEDBACK:
		float2string (fChorusFeedback * 100.0f, text, kVstMaxParamStrLen);
		break;
	}
}

// ============================================================================================
// M郁o[֐
// ============================================================================================
void MyChorusVST::processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames)
{
	//́Ao͂2zœnB
	//͂-1.0f`1.0f̊ԂœnB
	//o͂-1.0f`1.0f̊ԂŏޕKvB
	//sampleFramesobt@̃TCY
	float* inL  =  inputs[0]; // p
	float* inR  =  inputs[1]; // Ep
	float* outL = outputs[0]; //o p
	float* outR = outputs[1]; //o Ep

	float smplrate = getSampleRate();
	float dt = 1.0f / smplrate;
	float period = smplrate / fChorusRate;
	float pi = 3.14159265f;

	while (sampleFrames > 0)
	{
		//ŉsB

		float readpointL = (smplrate * fChorusDepth / 2000.0f) * sin(2 * pi * fTime / period);
		float readpointR = (smplrate * fChorusDepth / 2000.0f) * cos(2 * pi * fTime / period);

		//o̓obt@֏ށB
		(*outL) = (1.0f - fChorusDW) * (*inL) + fChorusDW * RingBufL.GetValueWithLerp(readpointL);
		(*outR) = (1.0f - fChorusDW) * (*inR) + fChorusDW * RingBufR.GetValueWithLerp(readpointR);

		RingBufL.SetValue( (*inL) + RingBufL.GetValueWithLerp(readpointL) * fChorusFeedback );
		RingBufR.SetValue( (*inR) + RingBufR.GetValueWithLerp(readpointR) * fChorusFeedback );

		fTime ++;
		if (fTime > period)
		{
			fTime -= period;
		}

		inL++;
		inR++;
		outL++;
		outR++;
		sampleFrames--;
	}

}

